#include <iostream>
#include <cstdlib>
#include "TinyHttpd.h"
using namespace std;

#pragma comment(lib,"TinyHttpd.lib")

class MyHttpd:public TinyHttpd{
public:
	MyHttpd():TinyHttpd(){
	};
	virtual bool onHttpRequest(SOCKET clientSocket,const char* uri,hmap* params){
		void* mem;
		FILE* fp;
		hmap headers;
		int fsize;
		if(strcmp(uri,"/hoverlees")==0){
			if((*params)["hello"]){
				//hello磺http://localhost/hoverlees?hello=1
				this->sendResponse(clientSocket,"Hello World!",12,0);
			}
			else this->sendResponse(clientSocket,"Hoverlees",9,NULL);
		}
		else if(strcmp(uri,"/pic")==0){ //http://localhost/pic
			fp=fopen("./1.png","rb");
			fseek(fp,0,SEEK_END);
			fsize=ftell(fp);
			mem=malloc(fsize);
			fseek(fp,0,SEEK_SET);
			fread(mem,1,fsize,fp);
			fclose(fp);
			headers["Content-Type"]="image/png";
			this->sendResponse(clientSocket,(char*)mem,fsize,&headers);
			free(mem);
		}
		else if(strcmp(uri,"/")==0){
			char* html="<html><body><a href='/hoverlees'>hoverlees</a> <a href='/pic'>Picture</a></body></html>";
			this->sendResponse(clientSocket,html,strlen(html),NULL);
		}
		else return false;
		return true;
	}
};

int main(int argc,char* argv[]){
	//
	MyHttpd* httpd=new MyHttpd();
	//
	httpd->startServer(80);
	while(1){
		Sleep(10000);
	}
	return 0;
}